Index: src/main/java/it/finki/charitable/controller/DonationPostController.java
===================================================================
--- src/main/java/it/finki/charitable/controller/DonationPostController.java	(revision 0c3762577315aca1565b0a288c0a9a46f79e55d2)
+++ src/main/java/it/finki/charitable/controller/DonationPostController.java	(revision ee0e2972779503cbac7ff1584f4ff29c30bac548)
@@ -128,5 +128,5 @@
                         @RequestParam(required = false,defaultValue = "") String order) {
         Page<DonationPost> postList = donationPostService.findPaginated(page,6, sort, order, true);
-        if (postList.getSize() == 0) {
+        if (postList.getTotalElements() == 0) {
             model.addAttribute("noPosts", true);
             return "album";
Index: src/main/java/it/finki/charitable/controller/ModeratorController.java
===================================================================
--- src/main/java/it/finki/charitable/controller/ModeratorController.java	(revision 0c3762577315aca1565b0a288c0a9a46f79e55d2)
+++ src/main/java/it/finki/charitable/controller/ModeratorController.java	(revision ee0e2972779503cbac7ff1584f4ff29c30bac548)
@@ -39,5 +39,5 @@
                            @RequestParam(required = false,defaultValue = "") String order) {
         Page<DonationPost> postList = donationPostService.findPaginated(page, 6, sort, order, false);
-        if (postList.getSize() == 0) {
+        if (postList.getTotalElements() == 0) {
             model.addAttribute("noPosts", true);
             return "postApproval";
@@ -72,5 +72,5 @@
         donationPostService.save(post);
         emailService.sendApprovalEmail(post.getUser().getEmail(), "CharitAbleMk: " + post.getTitle() + " has been approved", postid);
-        return "redirect:/moderator/approval";
+        return "redirect:/moderator/approval?page=1&sort=id";
     }
 
@@ -81,15 +81,19 @@
         emailService.sendNoApprovalEmail(post.getUser().getEmail(), "CharitAbleMk: " + post.getTitle() + " has not been approved", description);
         deleteDonationPost(post);
-        return "redirect:/moderator/approval";
+        return "redirect:/moderator/approval?page=1&sort=id";
     }
 
     @RequestMapping("/moderator/myApprovedPosts")
-    public String myApprovedPosts(Model model) {
+    public String myApprovedPosts(Model model,
+                                  @RequestParam int page,
+                                  @RequestParam String sort,
+                                  @RequestParam(required = false,defaultValue = "") String order) {
         Moderator moderator = (Moderator) SecurityContextHolder.getContext().getAuthentication().getPrincipal();
-        List<DonationPost> postList = donationPostService.findAllByModerator(moderator);
-        if (postList.size() == 0) {
+        Page<DonationPost> postList = donationPostService.findAllByModerator(page, 6, sort, order, moderator);
+        if (postList.getTotalElements() == 0) {
             model.addAttribute("noPosts", true);
             return "postApproval";
         }
+        model.addAttribute("totalPages", postList.getTotalPages());
         model.addAttribute("postList", postList);
         return "postApproval";
@@ -102,8 +106,9 @@
                                 @RequestParam(required = false,defaultValue = "") String order) {
         Page<ReportPost> postList = reportPostService.findAll(page, 6, sort, order);
-        if (postList.getSize() == 0) {
+        if (postList.getTotalElements() == 0) {
             model.addAttribute("noPosts", true);
             return "reportedPosts";
         }
+        model.addAttribute("totalPages",postList.getTotalPages());
         model.addAttribute("postList", postList);
         return "reportedPosts";
@@ -130,5 +135,5 @@
         ReportPost post = reportPostService.findById(postid);
         deleteReportPost(post);
-        return "redirect:/moderator/report";
+        return "redirect:/moderator/report?page=1&sort=id";
     }
 
@@ -141,5 +146,5 @@
         deleteReportPost(post);
         deleteDonationPost(donationPost);
-        return "redirect:/moderator/approval";
+        return "redirect:/moderator/approval?page=1&sort=id";
     }
 
Index: src/main/java/it/finki/charitable/repository/DonationPostRepository.java
===================================================================
--- src/main/java/it/finki/charitable/repository/DonationPostRepository.java	(revision 0c3762577315aca1565b0a288c0a9a46f79e55d2)
+++ src/main/java/it/finki/charitable/repository/DonationPostRepository.java	(revision ee0e2972779503cbac7ff1584f4ff29c30bac548)
@@ -15,5 +15,5 @@
     List<DonationPost> findAllByUser(AppUser user);
     List<DonationPost> findAllByApproved(Boolean approved);
-    List<DonationPost> findAllByModerator(Moderator moderator);
+    Page<DonationPost> findAllByModerator(Pageable pageable, Moderator moderator);
     Page<DonationPost> findAllByApproved(Pageable pageable, boolean approved);
 }
Index: src/main/java/it/finki/charitable/services/DonationPostService.java
===================================================================
--- src/main/java/it/finki/charitable/services/DonationPostService.java	(revision 0c3762577315aca1565b0a288c0a9a46f79e55d2)
+++ src/main/java/it/finki/charitable/services/DonationPostService.java	(revision ee0e2972779503cbac7ff1584f4ff29c30bac548)
@@ -46,6 +46,9 @@
     }
 
-    public List<DonationPost> findAllByModerator(Moderator moderator) {
-        return donationPostRepository.findAllByModerator(moderator);
+    public Page<DonationPost> findAllByModerator(int pageNo, int pageSize, String sort, String order, Moderator moderator) {
+        Sort s = Sort.by(sort);
+        s = order.equals("asc") ? s.ascending() : s.descending();
+        Pageable pageable = PageRequest.of(pageNo - 1, pageSize, s);
+        return donationPostRepository.findAllByModerator(pageable, moderator);
     }
 
